package com.dayorganiser.jgantt.combined.swing.table;

import com.dayorganiser.jgantt.drawing.Drawing;

import com.dayorganiser.jgantt.model.DrawingModel;

import java.awt.Component;

import javax.swing.JTable;

import javax.swing.table.TableCellRenderer;

public class DrawingCellRenderer implements TableCellRenderer
{
	protected Drawing drawing;

	public DrawingCellRenderer(Drawing drawing)
	{
		this.drawing = drawing;
	}

	//___________________________________________________________________________

	public Component getTableCellRendererComponent(JTable table, Object value,
		boolean isSelected, boolean hasFocus, int row, int column)
	{
		if (!(value instanceof DrawingModel))
			return null;

		DrawingModel drawingModel = (DrawingModel) value; // pretty much an assert
		drawing.setDrawingModel(drawingModel);

		return  (Component) drawing; // assumes drawing is a component
	}
}