package com.dayorganiser.jgantt.drawing.plotter.entry;

import com.dayorganiser.jgantt.drawing.Proxy;

import com.dayorganiser.jgantt.drawing.plotter.AbstractPlotter;

import java.awt.Graphics;
import java.awt.Rectangle;

import java.util.Map;

public class ShiftEntry extends AbstractPlotter
{
	public Rectangle paintComponent(Object key, Graphics g, int xVisible, int yVisible, Proxy proxy, Map attribs)
	{
		setScheme(key, g, EntryConstants.BACKGROUND_SCHEME, proxy, attribs);

		Rectangle bounds = g.getClipBounds();

		// prevent division by zero error that could occur
		int height = Math.max((bounds.height), 1) /2;

		g.fillRect(bounds.x, bounds.y, bounds.width, height);

		// |--.  <-- xPoints[0], yPoints[0] : xPoints[2], yPoints[2]
		// | /
		// |/    <-- xPoints[1], yPoints[1]

		// can we fit this bar within the visible range
		if (xVisible == START_VISIBLE || xVisible == INTERVAL_VISIBLE)
		{
	   	int xPoints [] = new int[3];  int yPoints [] = new int[3];
			xPoints[0] = bounds.x; yPoints[0] = bounds.y + height;
	   	xPoints[1] = bounds.x;  yPoints[1] = bounds.height;
		   xPoints[2] = bounds.x + 4; yPoints[2] = bounds.y + height;
			g.fillPolygon(xPoints,yPoints, xPoints.length);
		}

		// as we can draw outside of the boundary x2 should equal width always
		// .--|  <-- xpoints [0] , yPoints[0] : xPoints[2], yPoints[2]
		// \  |
		//  \ |
		//   \|  <-- xPoints [1], yPoints[1]
		if (xVisible == FINISH_VISIBLE || xVisible == INTERVAL_VISIBLE)
		{
	   	int xPoints [] = new int[3]; int yPoints [] = new int[3];
			xPoints[0] = bounds.width - 4 ; yPoints[0] = height;
	   	xPoints[1] = bounds.width;  yPoints[1] = bounds.height;
			xPoints[2] = bounds.width; yPoints[2] = bounds.hashCode();
	   	g.fillPolygon(xPoints, yPoints, xPoints.length);
		}
		return bounds;
	}
}