package com.dayorganiser.jgantt.drawing.plotter.entry;

import com.dayorganiser.jgantt.drawing.Proxy;

import java.awt.Graphics;
import java.awt.Rectangle;

import java.util.Map;

public class TaskBarEntry extends DefaultEntry
{
	public Rectangle paintComponent(Object key, Graphics g, int xVis, int yVis,
		Proxy proxy, Map attribs)
	{
		Rectangle bounds = g.getClipBounds();
		int height = Math.max(bounds.height, 1) /2; 	// prevent division by zero error that could occur

		super.paintComponent(key, g.create(bounds.x, bounds.y, bounds.width, height),
		   xVis, yVis, proxy, attribs);

		setScheme(key, g, EntryConstants.BACKGROUND_SCHEME, proxy, attribs);

		g = g.create(bounds.x , bounds.y + height, bounds.width, height);

		bounds = g.getClipBounds(); // should be identical to first clipbounds except height

		// |--.  <-- xPoints[0], yPoints[0] : xPoints[2], yPoints[2]
		// | /
		// |/    <-- xPoints[1], yPoints[1]

		int offset = (int) Math.round(height * 1.8);

		// can we fit this bar within the visible range
		if (xVis == START_VISIBLE || xVis == INTERVAL_VISIBLE)
		{
	   	int xPoints [] = new int[3];  int yPoints [] = new int[3];
			xPoints[0] = bounds.x; yPoints[0] = bounds.y ;
	   	xPoints[1] = bounds.x + (offset /2);  yPoints[1] = bounds.y + height;
		   xPoints[2] = bounds.x + offset; yPoints[2] = bounds.y ;
			g.fillPolygon(xPoints,yPoints, xPoints.length);
		}

		// as we can draw outside of the boundary x2 should equal width always
		// .--|  <-- xpoints [0] , yPoints[0] : xPoints[2], yPoints[2]
		// \  |
		//  \ |
		//   \|  <-- xPoints [1], yPoints[1]
		if (xVis == FINISH_VISIBLE || xVis == INTERVAL_VISIBLE)
		{
	   	int xPoints [] = new int[3]; int yPoints [] = new int[3];
			xPoints[0] = bounds.x + bounds.width - offset ; yPoints[0] = bounds.y;
	   	xPoints[1] = bounds.x + bounds.width - (offset /2);  yPoints[1] = bounds.y + height;
			xPoints[2] = bounds.x + bounds.width; yPoints[2] = bounds.y;
	   	g.fillPolygon(xPoints,yPoints, xPoints.length);
		}

		//return new Rectangle(x1,y1,x2,y2);
		return null;
	}
}