package com.dayorganiser.jgantt.drawing.plotter.marker;

import com.dayorganiser.jgantt.drawing.Proxy;

import com.dayorganiser.jgantt.drawing.plotter.AbstractPlotter;

import com.dayorganiser.jgantt.model.ModelConstants;

import java.awt.Graphics;
import java.awt.Rectangle;

import java.util.Map;

public class DefaultMarker extends AbstractPlotter
{
	/** most of the co-ordinates are of no relevance to most marker plotter implementations */
	public Rectangle paintComponent(Object key, Graphics g, int xVisible, int yVisible,
		Proxy proxy, Map attribs)
	{
		if (xVisible != INTERVAL_VISIBLE && xVisible != START_VISIBLE)
		   return null;

		setFont(key, g, MarkerConstants.FONT_SCHEME, proxy, attribs);
		String value = (String) attribs.get(ModelConstants.ENTRY_TEXT);

		Rectangle bounds = g.getClipBounds();

		// fix up the code to use the entire gradient this is important
		int x2 = Math.min(g.getFontMetrics().stringWidth(value) + bounds.x,
		   bounds.x + bounds.width);

		setScheme(key, g, MarkerConstants.BACKGROUND_SCHEME, proxy, attribs);

		g.drawString(value != null
		   ? value : "", bounds.x, bounds.y + g.getFontMetrics().getAscent());
		return null; // to do calc string height, width */
	}
}