package com.dayorganiser.jgantt.drawing.plotter.marker;

import com.dayorganiser.jgantt.drawing.Proxy;

import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;

import java.awt.image.ImageObserver;

import java.util.Map;

public class IconMarker extends DefaultMarker implements ImageObserver
{
	protected int spacer; // the spacer is the space between the icon and the marker
	protected Image image;

	public IconMarker(Image image, int spacer)
	{
		this.image = image;
		this.spacer = spacer;
	}

	/** most of the co-ordinates are of no relevance to most marker plotter implementations */
	public Rectangle paintComponent(Object key, Graphics g, int xVisible, int yVisible,
		Proxy proxy, Map attribs)
	{
		if (xVisible != INTERVAL_VISIBLE && xVisible != START_VISIBLE)
		   return null;

		// when the icon has been painted the image observer is called
		if (image != null)
			g.drawImage(image,1,1,this);

		// next we should draw the text
		int newSpacer = spacer + image.getWidth(this);
		Rectangle bounds = g.getClipBounds();
		return super.paintComponent(key, g.create(bounds.x + spacer , bounds.y,
		   bounds.width - spacer, bounds.height), xVisible, yVisible, proxy, attribs );
	}

	//_ImageObserver interface___________________________________________________

	/** although we do not neccesarily care about imageUpdates we should at
		least notify that we accept them, under normal circumstances this is
		the role of the component at this stage we don't neccearily have the
		appropriate component so.. */
	public boolean imageUpdate(Image img, int infoflags,
		int x, int y, int width, int height)
	{
		return true;
	}
}