package com.dayorganiser.jgantt.drawing.proxy.entry;

import java.util.Map;

import com.dayorganiser.jgantt.drawing.Proxy;

import com.dayorganiser.jgantt.drawing.scheme.Scheme;
import com.dayorganiser.jgantt.drawing.scheme.SchemeProvider;

import com.dayorganiser.jgantt.drawing.scheme.range.SchemeRange;

/** the default proxy is just a wrapper for the default proxy options */
public class DefaultEntryProxy implements Proxy
{
	protected int level;

	protected final Map attributes;
	protected final SchemeProvider schemeProvider;

	public DefaultEntryProxy(int level, SchemeProvider schemeProvider, Map attributes)
	{
		this.attributes = attributes;
		this.schemeProvider = schemeProvider;
		this.level = level;
	}

	//___________________________________________________________________________

	public Map getAttributes(Object key)
	{
		return attributes;
	}

	//___________________________________________________________________________

	public int getLevel(Object key)
	{
		return level;
	}

	//___________________________________________________________________________

	public SchemeRange getRange(Object o, String key)
	{
		return new LocalRange();
	}

	//___________________________________________________________________________

	public Scheme getScheme(Object key)
	{
		return schemeProvider.getScheme((String) key);
	}

	//___________________________________________________________________________

	protected class LocalRange implements SchemeRange
	{
		public int getStart()
		{
		   return 0;
		}

		public int indexOf(Object o)
		{
		   return 0;
		}

		public int getFinish()
		{
		   return 2;
		}
	}
}