package com.dayorganiser.jgantt.drawing.scheme;

import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class CombinedSchemeProvider implements SchemeProvider
{
	protected Set schemes = new HashSet();

	//___________________________________________________________________________

	/** the order of preference should be the order of addition into the provider*/
	public Scheme getScheme(String key)
	{
		for (Iterator iter = schemes.iterator(); iter.hasNext();)
		{
			SchemeProvider schemeProvider = (SchemeProvider) iter.next();
		   Scheme scheme= schemeProvider.getScheme(key);
			if (scheme != null)
				return scheme;
		}
		return null;
	}

	//___________________________________________________________________________

	public boolean add(Object o)
	{
		return schemes.add(o);
	}

	public boolean remove(Object o)
	{
		return schemes.remove(o);
	}
}