package com.dayorganiser.jgantt.drawing.scheme;

import com.dayorganiser.jgantt.drawing.scheme.range.SchemeRange;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class EnumeratedScheme implements Scheme
{
	protected Map schemes = new HashMap();
	protected Object defaultValue;

	public EnumeratedScheme(Collection collection)
	{
		int i=0;
		for (Iterator iter = collection.iterator(); iter.hasNext();)
			schemes.put(new Integer(i++), iter.next());
	}
	//___________________________________________________________________________

	public Object put(int index, Object o)
	{
		return schemes.put(new Integer(index), o);
	}

	public Object remove(int index, Object o)
	{
		return schemes.remove(new Integer(index));
	}

	//___________________________________________________________________________

	public void setDefaultValue(Object defaultValue)
	{
		this.defaultValue = defaultValue;
	}

	//___________________________________________________________________________

	/** range is nullable for enumerated scheme it's not used */
	public Object getObjectAt(int index, SchemeRange range)
	{
		Object value = schemes.get(new Integer(index));
		return value != null ? value : defaultValue;
	}
}