package com.dayorganiser.jgantt.drawing.scheme.color;

import com.dayorganiser.jgantt.drawing.scheme.range.SchemeRange;

import java.awt.Color;

import java.util.Collection;
/** this class will increase the color range by 1, inorder to
	make sure that every entries has access to two colors */
public class GradientScheme extends HSBScheme
{
	protected boolean cyclic = true;

	public GradientScheme(Collection collection)
	{
		super(collection);
	}

	public GradientScheme(Color color1, Color color2)
	{
		super(color1, color2);
	}

	/** should we recycle throught colors once we have used them*/
	public boolean isCyclic()
	{
		return cyclic;
	}

	//___________________________________________________________________________

	public Object getObjectAt(int index, SchemeRange range)
	{

		// need to hack range to +1;

		LocalRange lRange = new LocalRange(range.getStart(), range.getFinish() + 1);
		if (index <= range.getFinish())
		   return super.getObjectAt(index, lRange);

		index -= (range.getFinish() - range.getStart()) /2;
		return (Color) super.getObjectAt(index +1, lRange);
	}

	//___________________________________________________________________________

	public class LocalRange implements SchemeRange
	{
		protected int start;
		protected int finish;

		public LocalRange(int start, int finish)
		{
		   this.start = start;
		   this.finish = finish;
		}

		//________________________________________________________________________

		/** not supported */
		public int indexOf(Object o)
		{
		   return -1;
		}

		//________________________________________________________________________

		public int getStart()
		{
		   return start;
		}

		public int getFinish()
		{
		   return finish;
		}
	}
}