package com.dayorganiser.jgantt.drawing.scheme.color;

import com.dayorganiser.jgantt.drawing.scheme.Scheme;

import com.dayorganiser.jgantt.drawing.scheme.range.SchemeRange;

import java.awt.Color;

import java.util.Collection;
import java.util.Iterator;

public class HSBScheme implements Scheme
{
	protected Color colors [] = new Color[2];

	/** specifying an empty collection just won't work here */
	public HSBScheme(Collection collection)
	{
		Iterator iter = collection.iterator();
		colors [0] = (Color) iter.next();
		colors [1] = iter.hasNext() ? (Color) iter.next() : colors[0];
	}

	public HSBScheme(Color color1, Color color2)
	{
		this.colors[0] = color1;
		this.colors[1] = color2;
	}

	//___________________________________________________________________________

	public Object getObjectAt(int index, SchemeRange range)
	{
		return index == 0 ? colors[0] : colors[1];
	}
}