package com.dayorganiser.jgantt.model;

import java.util.Collection;
import java.util.Map;

import com.dayorganiser.jgantt.model.event.ModelListener;

import com.dayorganiser.util.Interval;

/**
	The diagram model is the information behind the actual diagram panel for table
	functionality it is advisable to extend the diagram model as maintaining two
	models is easier than maintaining the one */
public interface DrawingModel
{
	void addModelListener(ModelListener listener);

	void removeModelListener(ModelListener listener);

	//___________________________________________________________________________

	Collection getEntries();

	/** returns an interval */
	Interval getInterval(Object key, int orientation);

	//___________________________________________________________________________

	/**does not return an actual axis but a reference key to one */
	Object getAxis(Object key, int orientation);

	/** the attributes is additional information that is required by the plotter
		this should not be style information as this is proxy!! i.e. for a
		textMarker this would be a string, activity an int between 1 & 100 */
	Map getAttributes(Object o);

	//___________________________________________________________________________

	Object getPlotter(Object key);

	Object getProxy(Object key);
}