package com.dayorganiser.jgantt.model.axis;

import java.util.Iterator;
import java.util.Vector;

import com.dayorganiser.jgantt.model.Axis;

import com.dayorganiser.util.Interval;

public class FloatAxis extends AbstractAxis
{
	public FloatAxis(String name)
	{
		super(name);
	}

	//___________________________________________________________________________

	public int getGranularity(int width, int min)
	{
		float range = ((Float)visible.getRange()).floatValue();
	   float offset = range / width;
		return new Float(min * offset).intValue();
	}

	public double getWidth(int width, int granularity)
	{
		// todo hard maths
		//		float range = ((Float)visible.getRange()).floatValue();
		//   float offset = range / width;

		return width;
	}

	//___________________________________________________________________________

	public int getPoint(int width, Object o)
	{
		float range = ((Float)visible.getRange()).floatValue();
	   float offset =  width / range;
		float value = ((Float) o).floatValue() - ((Float) visible.getStart()).floatValue();
		return new Float(offset * value).intValue();
	}

	public Object getValue(int a, int b)
	{
		return new Float(3); //nasty maths todo
	}

	//___________________________________________________________________________

	public boolean zoom(int level)
	{
		return true;
	}

	//___________________________________________________________________________

	public Iterator visibleIterator(int granularity)
	{
		return new FloatIterator( ((Float)visible.getStart()).floatValue(),
		   ((Float) visible.getFinish()).floatValue(), granularity);
	}

	//___________________________________________________________________________

	protected class FloatIterator implements Iterator
	{
		protected float increment;
		protected float start;
		protected float finish;

		public FloatIterator(float start, float finish, float increment)
		{
		   this.increment = increment;
  		   this.finish = finish;
		   this.start = start;
		}

		public boolean hasNext()
		{
		   return finish > start;
		}

		public Object next()
		{
		   float temp = start;
		   start += increment;
		   return new Float(temp);
		}

		/** doesn't make much sense here */
		public void remove()
		{
		}
	}
}