package com.dayorganiser.jgantt.model.drawing;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.dayorganiser.jgantt.model.DrawingModel;

import com.dayorganiser.jgantt.model.event.ModelListener;

/** the AbstractModel is designed to take some of the heart-ache out of the design
	of the model design which is a bit complicated for most users */
public abstract class AbstractModel implements DrawingModel
{
	protected List changeListeners = new ArrayList(2);

	//___________________________________________________________________________

	public synchronized void addModelListener(ModelListener modelListener)
	{
		changeListeners.add(modelListener);
	}

	public synchronized void removeModelListener(ModelListener modelListener)
	{
		changeListeners.remove(modelListener);
	}

	//_fire_changes______________________________________________________________

	protected void fireRefresh()
	{
		synchronized (this)
		{
		   for (Iterator iter = changeListeners.iterator(); iter.hasNext();)
		   {
				ModelListener listener = (ModelListener) iter.next();
				listener.refresh();
		   }
		}
	}
}