package com.dayorganiser.jgantt.model.range;

import java.util.EventListener;

import javax.swing.BoundedRangeModel;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;

/** this all based on the swing source code */
public abstract class AbstractRangeModel implements BoundedRangeModel
{
	protected transient ChangeEvent changeEvent = null;

	protected int visibleRows = 0;
	protected boolean isAdjusting = false;
	protected EventListenerList listenerList = new EventListenerList();


	//___________________________________________________________________________

	public int getVisibleRows()
	{
		return visibleRows;
	}

	public void setVisibleRows(int visibleRows)
	{
		this.visibleRows = visibleRows;
	}

	//___________________________________________________________________________

	public boolean getValueIsAdjusting()
	{
		return isAdjusting;
	}

	public void setValueIsAdjusting(boolean isAdjusting)
	{
		this.isAdjusting = isAdjusting;
   }

	//___________________________________________________________________________

	public void addChangeListener(ChangeListener l)
	{
		listenerList.add(ChangeListener.class, l);
	}

	public void removeChangeListener(ChangeListener l)
	{
		listenerList.remove(ChangeListener.class, l);
	}

	//___________________________________________________________________________

	public EventListener[] getListeners(Class listenerType)
	{
	   return listenerList.getListeners(listenerType);
	}

	//_Not of interest to our implementation_____________________________________

	public void setExtent(int n)
	{
	}

	public void setMinimum(int n)
	{
	}

	public void setMaximum(int n)
	{
	}

   public void setRangeProperties(int newValue, int newExtent, int newMin, int newMax, boolean adjusting)
	{
	}

	//___________________________________________________________________________

	/** this method was lifted from swing code*/
	protected void fireStateChanged()
	{
		Object[] listeners = listenerList.getListenerList();
		for (int i = listeners.length - 2; i >= 0; i -=2 )
		   if (listeners[i] == ChangeListener.class)
		   {
				if (changeEvent == null)
					changeEvent = new ChangeEvent(this);
				((ChangeListener)listeners[i+1]).stateChanged(changeEvent);
		   }
	}
}
