package com.dayorganiser.jgantt.model.range;

import com.dayorganiser.jgantt.model.ScrollableModel;

public class RowRangeModel extends AbstractRangeModel
{
	protected ScrollableModel model;

	public RowRangeModel(ScrollableModel model)
	{
		this.model = model;
	}

	//___________________________________________________________________________

	/** the extent is the visible portion on the screen */
	public int getExtent()
	{
		return 1; // will always be 1
	}

	public int getValue()
	{
		return model.getTopRow();
   }

	//___________________________________________________________________________

   public int getMinimum()
	{
		return 0;
	}

	public int getMaximum()
	{
		return Math.max(model.size(), 0);
	}

	//___________________________________________________________________________

	public void setValue(int value)
	{
		// You really can't trust the scrollbar to do the right thing so lets be safe
		value = Math.max(0, value);

		int visible = Math.max(model.size(), 0);

		value = Math.min(value, visible);

		model.setTopRow(value);

		fireStateChanged();
   }
}