package com.dayorganiser.jgantt.panel.diagram;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import com.dayorganiser.jgantt.drawing.agent.DrawingHelperAgent;

import com.dayorganiser.jgantt.drawing.drawing.DrawingHelper;

import com.dayorganiser.jgantt.model.SelectionModel;

public class DefaultMouseListener
	implements DrawingHelperAgent, MouseListener
{
	protected DrawingHelper drawingHelper;
	protected SelectionModel model;

	public DefaultMouseListener(SelectionModel model)
	{
		this.model = model;
	}

	public void setDrawingHelper(DrawingHelper drawingHelper)
	{
		this.drawingHelper = drawingHelper;
	}

	//___________________________________________________________________________

	public void mouseClicked(MouseEvent event)
	{
	   if (event.getClickCount() == 1)
	   {
		   Object key = drawingHelper.getKeyAt(event.getPoint(),true);

			if (key != null && model.select(key,event))
				drawingHelper.fireRepaint();
	   }
	}

	//_these could be used for some very nice effects____________________________

   public void mouseEntered(MouseEvent event)
	{
	}

	public void mousePressed(MouseEvent event)
	{
	}

	public void mouseReleased(MouseEvent event)
	{
	}

	public void mouseExited(MouseEvent event)
	{
	}
}