package com.dayorganiser.treetable.model;

import java.io.File;

import java.util.ArrayList;
import java.util.Date;
import java.util.Enumeration;
import java.util.List;

import javax.swing.JTree;

import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.DefaultMutableTreeNode;

import javax.swing.tree.TreePath;

import javax.swing.table.TableModel;

import javax.swing.event.TableModelListener;

import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.TreeModel;
import javax.swing.tree.TreeNode;

/**
	This is designed to be a combination of a tree, and a table model, it's not
	nice but one of the easiest ways to do it.

	step one: add your columns
	step two: populate the tree with nodes, user object should be array lists
	step three: initialise the tree*/
public class DefaultTreeTableModel extends DefaultTreeModel implements TableModel, TreeModel
{
	protected List columns = new ArrayList(5);

	protected JTree tree; // used for calculate the position

	public DefaultTreeTableModel()
	{
		super(new DefaultMutableTreeNode(new File(File.separator)));
	}

	public void initialise(JTree tree)
	{
		this.tree = tree;
	}

	//___________________________________________________________________________

	public void addColumn(Object columnName)
	{
		columns.add(columnName);
	}

	//_TableModel interface______________________________________________________

	public int getColumnCount()
	{
		return columns.size();
   }

	public String getColumnName(int column)
	{
		return (String) columns.get(column);
   }

	public Class getColumnClass(int column)
	{
		return Object.class;
   }

	public int getRowCount()
	{
		return tree.getVisibleRowCount();
	}

	public Object getValueAt(int row, int col)
	{
		Object node = getNode(row);
		return node != null ? getValueAt(node, col) : null;
	}

		/** not implemented yet */
	public void setValueAt(Object o, int i, int z)
	{
	}

	public boolean isCellEditable(int row,  int b)
	{
		return true;
	}

	//_table_helpers___________________________________________________________________

   public Object getValueAt(Object node, int column)
	{
	   List values = (List) ((DefaultMutableTreeNode) node).getUserObject();
		return column > values.size() ? null : values.get(column);
	}

	//___________________________________________________________________________

   public void addTableModelListener(TableModelListener l)
	{
	}

   public void removeTableModelListener(TableModelListener l)
	{
	}

	//___________________________________________________________________________

	protected Object getNode(int row)
	{
	   TreePath treePath = tree.getPathForRow(row);
	   return treePath != null ? treePath.getLastPathComponent() : null;
	}
}