package com.dayorganiser.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;

import java.net.URL;

import java.util.HashMap;
import java.util.ResourceBundle;

import com.dayorganiser.util.files.Hive;

public class Trace
{
	private static String THIS = Trace.class.getName();
	private static boolean TRACE; // value will be setup at the end of the static constructor

	public static String DELIMITER = "=";
	public static String CLASS_SPLITTER = ".";
	public static String TRACE_CONFIG = "trace.cfg";

	private static HashMap traceEnable = new HashMap();
	private static ResourceBundle bundle;

	public static PrintStream out = System.out;

	static
	{
		URL url = Hive.getURL(TRACE_CONFIG);

		if (url != null)
		{
		   try
		   {
			   InputStream input = url.openStream();
				BufferedReader in = new BufferedReader(new InputStreamReader(input));
				for (String line = line = in.readLine(); line != null; line = in.readLine())
				{
					// split based on the delimiter
					int i = line.indexOf(DELIMITER);
					if (i <= 0)
						continue;

					// line is something like test.jclass=true;
				   // name becomes something like test.jclass
				   // value becomes true or false
					String name = line.substring(0, i).trim();
					String value = line.substring(i + 1).trim();

					traceEnable.put(name, Boolean.valueOf(value).booleanValue() ? Boolean.TRUE : Boolean.FALSE);
				}
		      input.close();
		   }
		   catch (IOException io)
		   {  // this exception is not expecting so we must trace :(
				System.out.println(io);
		   }
		}

		// update the Tracing for this class based on the configuration
		TRACE = getEnable(THIS);
	}

	//___________________________________________________________________________

	public static boolean getEnable(String s)
	{
		if (TRACE) Trace.out.println(THIS + ".getEnable() preforming lookup on key " + s);

		for (int i=0; i >=0; i=s.lastIndexOf('.'))
		{
			Boolean value = (Boolean) traceEnable.get(s);
			if (value != null)
				return value.booleanValue();

		   // next element
			s = s.substring(0, i);
		}
		return false;
	}

	//___________________________________________________________________________

	/** this method has to be synchronized just in case something else could be
		writing out to the trace */
	public static synchronized void setOut(PrintStream newOut)
	{
		out = newOut;
	}
}