package com.dayorganiser.util.time;

import com.dayorganiser.util.Interval;

public class DefaultTimeInterval implements TimeInterval
{
	protected long start;
	protected long finish;

	public DefaultTimeInterval(long start, long finish)
	{
		this.start = start;
		this.finish = finish;
	}

	//___________________________________________________________________________

	public Object getStart()
	{
		return new Long(start);
	}

	public Object getFinish()
	{
		return new Long(finish);
	}

	//___________________________________________________________________________

	public Object getRange()
	{
		return new Long(finish - start);
	}

	//___________________________________________________________________________

	/** time is in millis*/
	public long getStartTime()
	{
		return start;
	}

	/** time is in millis*/
	public long getFinishTime()
	{
		return finish;
	}

	//___________________________________________________________________________

	public boolean containsValue(Object o)
	{
		long value = ((Long) o).longValue();
		return this.start <= value  && this.finish >= value;
	}

	public boolean contains(Interval i)
	{
		TimeInterval interval = (TimeInterval) i;
		return this.start <= interval.getStartTime() &&
		   this.finish >= interval.getFinishTime();
	}

	public boolean intersects(Interval i)
	{
		return !(finish < ((Long)i.getStart()).longValue())
		   || !(start > ((Long)i.getFinish()).longValue());
	}
}