package test.jgantt.dao;

import java.util.ArrayList;
import java.util.Collection;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.sql.SQLException;

/**
 * @author Raul Davidovich
 */

/**
  * DAO (Data:Access:Object) is an implementation of a generic data source
  * which allows for queries to be built against a dataset belonging to a data source
  * a less advanced version of data provider
 **/
public class DAO
{
	protected static DAO instance; // why do we need an instance sounds odd

	public static DAO getInstance() throws SQLException
	{
		if (instance == null)
			instance = new DAO(); // update the shared instance
		return instance;
	}

	//___________________________________________________________________________

	/** assume this is some kind of getDataSet ? */
	public Collection findAll(String name) throws SQLException
	{
		Connection c = ConnectionManager.getInstance(name).getConnection();

		String query = "SELECT * FROM project";

		Collection results = new ArrayList();

	   Statement s = c.createStatement();
	   ResultSet r = s.executeQuery(query);
		while (r.next())
			results.add(new ValueObject(r.getInt(1), r.getString(2), r.getBoolean(3), r.getString(4)));

		s.close();
		return results;
  }
}