package test.jgantt.demo;

import com.dayorganiser.jgantt.drawing.Drawing;

import com.dayorganiser.jgantt.model.Axis;

import java.awt.BorderLayout;
import java.awt.Container;

import javax.swing.JPanel;
import javax.swing.JScrollPane;

import javax.swing.JToolBar;

import javax.swing.JTable;

public abstract class AbstractDemo
{
	protected Container container;

	public AbstractDemo(Container container)
	{
		this.container = container;
		container.setLayout(new BorderLayout());
	}

	//___________________________________________________________________________

	public void initialise()
	{
		container.add(new JScrollPane(createTable()), BorderLayout.CENTER);

		// indent the toolbar to the east
		JPanel panel = new JPanel(new BorderLayout());
	   panel.add(createToolBar(), BorderLayout.EAST);

		container.add(panel, BorderLayout.SOUTH);
	}

	//___________________________________________________________________________

	protected JToolBar createToolBar()
	{
		JToolBar toolbar = new JToolBar();
		toolbar.setFloatable(false);

		// add user based actions
		toolbar.add(new ExitAction("Close", null));
		return toolbar;
	}

	//___________________________________________________________________________

	protected abstract JTable createTable();
}