package test.jgantt.demo.project;

import com.dayorganiser.util.Interval;

import com.dayorganiser.util.time.DefaultTimeInterval;

import java.util.Date;

import java.sql.ResultSet;
import java.sql.SQLException;

public class Task
{
	protected int taskType;
	protected int uid;

	protected Date finish, start;
	protected String name;
	protected String rowID;

	public Task(ResultSet result) throws SQLException
	{
	   this.finish = result.getDate("TASK_FINISH_DATE");
		this.name = result.getString("TASK_NAME");
	   this.rowID = result.getString("TASK_OUTLINE_NUM");
		this.start = result.getDate("TASK_START_DATE");
		this.taskType = result.getInt("TASK_TYPE");
	   this.uid = result.getInt("TASK_ID");
	}

	//________________________________________________________________________

	public boolean isValid()
	{
	   return (start != null && finish != null && rowID != "0" && uid > 0);
	}

	//________________________________________________________________________

	public String getID()
	{
	   return rowID;
	}

	public int getUniqueID()
	{
	   return uid;
	}

	//________________________________________________________________________

	public String getName()
	{
	   return name;
	}

	public int getTaskType()
	{
	   return taskType;
	}

	public Interval getInterval()
	{
	  	return new DefaultTimeInterval(start.getTime(), finish.getTime());
	}
}