package test.treetable.filesystem;

import com.dayorganiser.treetable.component.swing.JTreeTable;

import java.awt.BorderLayout;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTree;

public class FileSystemDemo extends JFrame
{
	protected FileSystemModel model;
	protected JTreeTable treeTable;

	public FileSystemDemo()
	{
		super("Demonstration of JTreeTable rendering a local filesystem");

		this.model = new FileSystemModel();
		this.treeTable = new JTreeTable(model, model);

		addWindowListener(new WindowAdapter()
		{
			public void windowClosing(WindowEvent we)
		   {
				System.exit(0);
	      }
		});

		getContentPane().add(new JScrollPane(treeTable), BorderLayout.NORTH);
	}

	public void initialise()
	{
		model.initialise(treeTable.getTree());
	}

	//___________________________________________________________________________

	public static void main(String [] args)
	{
		FileSystemDemo demo = new FileSystemDemo();
		demo.initialise();
		demo.pack();
		demo.show();
	}
}